// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// Template A template definition. At rendering time, the "body" and "metadata"
// fields will be processed by the rendering engine corresponding to the
// template "language" to produce a new document.
// If you need to add metadata that should not be be processed, use
// "static-metadata"
//
//
// swagger:model template
type Template struct {

	// The template owner account name
	Account string `json:"account,omitempty" db:"account"`

	// activity
	Activity *Activity `json:"activity,omitempty"`

	// Content
	Body string `json:"body,omitempty" db:"-"`

	// The body attribute format. Can be 'text' or 'base64'. Default 'base64'
	BodyFormat string `json:"body-format,omitempty" db:"-"`

	// created at
	// Format: datetime
	CreatedAt strfmt.DateTime `json:"created-at,omitempty" db:"created_at"`

	// The json-schema that can validate the input data. Currently ignored.
	//
	DataSchema interface{} `json:"data-schema,omitempty" db:"data_schema"`

	// A description of the template
	Description string `json:"description,omitempty" db:"description"`

	// The templating language used. See
	// <a href="/docs/engines">Rednerd Engines</a> for a list of possible
	// values.
	//
	Language string `json:"language,omitempty" db:"language"`

	// The template default locale, in the i18n standard codification.
	//
	Locale string `json:"locale,omitempty" db:"locale"`

	// metadata
	Metadata Metadata `json:"metadata,omitempty" db:"metadata"`

	// The template name, must be unique in an account namespace,
	// and should remain simple as it is used as a slug.
	//
	Name string `json:"name,omitempty" db:"name"`

	// The mimetype of the data produced by the template. If the mimetype
	// is known by any engine, it can be rendered to other types.
	//
	Produces string `json:"produces,omitempty" db:"produces"`

	// static metadata
	StaticMetadata Metadata `json:"static-metadata,omitempty" db:"static_metadata"`

	// The template title.
	Title string `json:"title,omitempty" db:"title"`

	// The template version. Can be any string, the consistency of version
	// numbers is the responsibility of the client.
	//
	Version string `json:"version,omitempty" db:"version"`
}

// Validate validates this template
func (m *Template) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateActivity(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCreatedAt(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateMetadata(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStaticMetadata(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *Template) validateActivity(formats strfmt.Registry) error {

	if swag.IsZero(m.Activity) { // not required
		return nil
	}

	if m.Activity != nil {
		if err := m.Activity.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("activity")
			}
			return err
		}
	}

	return nil
}

func (m *Template) validateCreatedAt(formats strfmt.Registry) error {

	if swag.IsZero(m.CreatedAt) { // not required
		return nil
	}

	if err := validate.FormatOf("created-at", "body", "datetime", m.CreatedAt.String(), formats); err != nil {
		return err
	}

	return nil
}

func (m *Template) validateMetadata(formats strfmt.Registry) error {

	if swag.IsZero(m.Metadata) { // not required
		return nil
	}

	if err := m.Metadata.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("metadata")
		}
		return err
	}

	return nil
}

func (m *Template) validateStaticMetadata(formats strfmt.Registry) error {

	if swag.IsZero(m.StaticMetadata) { // not required
		return nil
	}

	if err := m.StaticMetadata.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("static-metadata")
		}
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *Template) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *Template) UnmarshalBinary(b []byte) error {
	var res Template
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
