package tests

import (
	"context"
	"testing"

	"github.com/stretchr/testify/assert"

	"orus.io/orus-io/rednerd/testutils/apitester"
)

func TestVarlist(t *testing.T) {
	ctx := context.Background()
	tester := apitester.NewAPITester(ctx, t, nil)
	defer tester.Close()

	defer tester.Logout()
	tester.Login("admin", "admin")

	tester.CreateUser("janedoe", "janedoe")
	tester.Login("janedoe", "janedoe")

	t.Run("mustache", func(t *testing.T) {
		defer tester.SetT(t)()
		var result []string
		tester.MustPostJSON(
			"/api/v1/varlist",
			apitester.JSONObj{
				"language":    "mustache",
				"produces":    "text/mjml",
				"body-format": "text",
				"body":        "<mjml> <mj-body> <mj-section> <mj-column> <mj-text>hello {{name}}</mj-text> </mj-column> </mj-section> </mj-body> </mjml>", //nolint:lll
			},
			&result,
		)

		assert.Equal(t, []string{
			"name",
		}, result)
	})
}
